<script setup lang="ts">
import Layout from "@/components/Layout.vue";
import Pagination from "@/components/Pagination.vue";
import Sidebar from "@/components/Sidebar.vue";
import BirdCard from "@/views/BirdhousesView/components/BirdCard/BirdCard.vue";
import { axios } from '@/libs/axios';
import { computed, onMounted, ref, watch } from "vue";
import { useRoute } from "vue-router";
import { BIRDHOUSES_PER_PAGE } from "@/views/BirdhousesView/constants/paginationConfig";
import { GET_BIRDHOUSES_ENDPOINT } from "@/views/BirdhousesView/constants/apiEndpoints";
import { GetBirdhousesResponse } from "@/views/BirdhousesView/types/response";
import { useToast } from "vue-toast-notification";

const route = useRoute();

const birdhouses = ref([]);
const totalItems = ref(0);
const currentPage = computed(() => {
  return route.query.page ?? 1
});

const $toast = useToast()

const fetchBirdhouses = async () => {
  try {
    const response: GetBirdhousesResponse = await axios.get(GET_BIRDHOUSES_ENDPOINT, {
      params: {
        limit: BIRDHOUSES_PER_PAGE,
        page: currentPage.value
      }
    });

    birdhouses.value = response.data;
    totalItems.value = response.total;
  } catch (error) {
    $toast.error('Error fetching birdhouses:', error)
  }
};

onMounted(() => {
  fetchBirdhouses();
});

watch(
    () => route.query.page,
    () => {
      fetchBirdhouses();
    }
);
</script>

<template>
  <Layout>
    <div class="flex">
      <!-- Sidebar -->
      <Sidebar/>

      <!-- Content -->
      <div class="flex-1 bg-very-dark-gray h-[84vh]">
        <!-- Card Grid -->
        <div class="p-8">
          <div class="grid grid-cols-1 md:grid-cols-4 lg:grid-cols-6 gap-6">
            <!-- Cards -->
            <router-link
                v-for="birdhouse in birdhouses"
                :key="birdhouse.id"
                :to="{ name: 'birdhouse', params: { id: birdhouse.id } }"
            >
              <BirdCard :birdhouse="birdhouse" />
            </router-link>
          </div>
        </div>
      </div>
    </div>

    <div class="flex justify-center items-center p-4">
      <Pagination
          :total-items="totalItems"
          :items-per-page="BIRDHOUSES_PER_PAGE"
      />
    </div>
  </Layout>
</template>
